Magellan Linux

Contents of /trunk/mage/usr/lib/mage/smage2.functions.sh

Parent Directory Parent Directory | Revision Log Revision Log


Revision 2365 - (show annotations) (download) (as text)
Mon Jan 6 12:56:50 2014 UTC (10 years, 3 months ago) by niro
File MIME type: application/x-sh
File size: 28633 byte(s)
-drop obsolete MAGE_TARGETS support
1 #!/bin/bash
2 # smage2 releated functions
3 # $Id$
4
5 # sources the smage file and uses state from distribution file if exist
6 # may helpful for repository support later on
7 smagesource()
8 {
9 local file="$1"
10 local localstate
11 local distfilestate
12 local mytag
13
14 source ${file}
15
16 # if PCAT was not set and PCATEGORIE was found
17 # inform the user and use PCATEGORIE as PCAT
18 if [[ -z ${PCAT} ]]
19 then
20 if [[ -n ${PCATEGORIE} ]]
21 then
22 PCAT="${PCATEGORIE}"
23 unset PCATEGORIE
24 # print a warning
25 echo -e "${COLYELLOW}Warning: 'PCATEGORIE' is deprecated and gets removed in the future.${COLDEFAULT}"
26 echo -e "${COLYELLOW} Please modify this smage2 script to use the 'PCAT' variable.${COLDEFAULT}"
27 echo
28 else
29 die "Neither PCAT nor PCATEGORIE are defined!"
30 fi
31 fi
32
33 [[ -n ${STATE} ]] && localstate="${STATE}"
34 [[ -n ${DISTROTAG} ]] && mytag="${DISTROTAG}"
35
36 if [ -f ${SMAGESCRIPTSDIR}/distribution ]
37 then
38 source ${SMAGESCRIPTSDIR}/distribution
39 [[ -n ${STATE} ]] && distfilestate="${STATE}"
40 [[ -n ${DISTROTAG} ]] && mytag="${DISTROTAG}"
41 fi
42 # now switch state and export it but do not overide any local states
43 if [[ ! -z ${localstate} ]]
44 then
45 STATE="${localstate}"
46 else
47 STATE="${distfilestate}"
48 fi
49
50 if mqueryfeature "pkgdistrotag"
51 then
52 # if DISTROTAG was not defined globally
53 # or in distribution file then deactivate this feature!
54 # at this point $mytag must have the distrotag
55 if [[ -z ${mytag} ]]
56 then
57 FVERBOSE=off msetfeature "!pkgdistrotag"
58 unset DISTROTAG
59 echo -e "${COLRED}Requested 'pkgdistrotag' but no \$DISTROTAG found!${COLDEFAULT}"
60 echo -e "${COLRED}Disabled the feature for pkgbuild sanity!${COLDEFAULT}"
61 else
62 # now switch state and export it but do not overide any local states
63 export DISTROTAG="${mytag}"
64 fi
65 else
66 unset DISTROTAG
67 fi
68 }
69
70 print_distrotag()
71 {
72 if FVERBOSE=off mqueryfeature "pkgdistrotag"
73 then
74 if [[ ! -z ${DISTROTAG} ]]
75 then
76 # add a point as prefix
77 echo ".${DISTROTAG}"
78 fi
79 fi
80 }
81
82 showversion()
83 {
84 echo -en "Magellan Source Install v${SMAGEVERSION} "
85 echo -e "-- Niels Rogalla (niro@magellan-linux.de)"
86 }
87
88 die()
89 {
90 xtitleclean
91 echo -e ${COLRED}"Exited ${BASH_SOURCE} at line no ${BASH_LINENO}."${COLDEFAULT}
92 echo "SMAGE failed: $@"
93 exit 1
94 }
95
96 die_pipestatus()
97 {
98 # the status change if we do any parameter declarations!!
99 # dont do this anymore, keep this in mind!
100 #
101 # local pos="$1"
102 # local comment="$2"
103 #
104 # [ ${PIPESTATUS[${pos}]} -ne 0 ] && die "${comment}"
105 #
106 [ ${PIPESTATUS[$1]} -ne 0 ] && die "$2"
107 }
108
109 xtitle()
110 {
111 if [[ ${TERM} = xterm ]]
112 then
113 echo -ne "\033]0;[sMage: $@]\007"
114 fi
115 return 0
116 }
117
118 xtitleclean()
119 {
120 if [[ ${TERM} = xterm ]]
121 then
122 echo -ne "\033]0;\007"
123 fi
124 return 0
125 }
126
127 syncsmage2()
128 {
129 xtitle "Updating smage2-script tree ..."
130 local i
131 for i in ${SMAGE2RSYNC}
132 do
133 rsync ${RSYNC_FETCH_OPTIONS} ${i} ${SMAGESCRIPTSDIR}
134 if [[ $? = 0 ]]
135 then
136 break
137 else
138 continue
139 fi
140 done
141
142 # clean up backup files (foo~)
143 find ${SMAGESCRIPTSDIR} -name *~ -exec rm '{}' ';'
144
145 xtitleclean
146 }
147
148 # $1 filename
149 get_db_md5_sum()
150 {
151 local DB_FILE
152 local MD5_FILE
153 local i
154
155 DB_ENTRY="$(basename $1)"
156 MD5_FILE="${MD5DIR}/$(basename ${SMAGENAME} ${SMAGESUFFIX})"
157
158 i="$(cat ${MD5_FILE}| grep ${DB_ENTRY} | cut -d' ' -f1)"
159
160 echo "${i}"
161 }
162
163 download_sources()
164 {
165 [ -z "${SRC_URI}" ] && echo -e "\nNothing declared to download.\n" && return 0
166
167 local count=${#SRC_URI[*]}
168 local uri
169 local subdir
170 local outputdir
171 local db_md5_file="${MD5DIR}/$(basename ${SMAGENAME} .${SMAGESUFFIX}).md5"
172 local fetching
173 local i
174
175 # check if FETCHING is needed
176 if mchecksum --rundir "${SOURCEDIR}/${PNAME}" --file "${db_md5_file}" --method md5
177 then
178 # md5's ok, no fetching needed
179 fetching=false
180 else
181 fetching=true
182 fi
183
184 if [[ ${fetching} = true ]]
185 then
186 for ((i=0; i < count; i++))
187 do
188 # url to file
189 uri="${SRC_URI[${i}]%%' '*}"
190
191 # subdir in sources dir; the my_SRCI_URI file goes to there
192 subdir="${SRC_URI[${i}]##*' '}"
193
194 # if $subdir is not equal with $uri then an other dir is used
195 if [[ ${uri} != ${subdir} ]]
196 then
197 outputdir="${SOURCEDIR}/${PNAME}/${subdir}"
198 else
199 outputdir="${SOURCEDIR}/${PNAME}"
200 fi
201
202 echo -e "${COLBLUE}==>${COLGREEN} fetching ${uri}${COLDEFAULT}"
203 # always use verbose mode for source downloads
204 FVERBOSE=off msetfeature "verbose"
205 # do not die here, mchecksum catches download errors
206 mdownload --uri "${uri}" --dir "${outputdir}"
207
208 # unset them to be sure
209 unset uri
210 unset subdir
211 unset outputdir
212 done
213
214 # recheck md5 sums after download
215 echo
216 echo -e "${COLBLUE}===${COLGREEN} Checking MD5 sums:${COLDEFAULT}"
217 mchecksum --rundir "${SOURCEDIR}/${PNAME}" --file "${db_md5_file}" --method md5 || die "md5 failed"
218 echo
219 else
220 echo -e "${COLBLUE}===${COLGREEN} All sources already fetched, nothing to do${COLDEFAULT}"
221 fi
222
223 # not needed anymore
224 unset SRC_URI
225 }
226
227 # dummy function, used if that does not exist in smage file
228 src_prepare()
229 {
230 echo "no src_prepare defined; doing nothing ..."
231 return 0
232 }
233
234 # dummy function, used if that does not exist in smage file
235 src_compile()
236 {
237 echo "no src_compile defined; doing nothing ..."
238 return 0
239 }
240
241 # dummy function, used if that does not exist in smage file
242 src_check()
243 {
244 echo "no src_check defined; doing nothing ..."
245 return 0
246 }
247
248 # dummy function, used if that does not exist in smage file
249 src_install()
250 {
251 echo "no src_install defined; doing nothing ..."
252 return 0
253 }
254
255 mlibdir()
256 {
257 local libdir=lib
258 [[ ${ARCH} = x86_64 ]] && libdir=lib64
259
260 echo "${libdir}"
261 }
262
263 mconfigure()
264 {
265 local myopts
266 if [[ ! -z ${CTARGET} ]]
267 then
268 myopts+=" --target=${CTARGET}"
269 fi
270
271 if [ -x ./configure ]
272 then
273 # if requested disable-static
274 if [[ ! -z $(./configure --help | grep -- '--.*able-static') ]]
275 then
276 if mqueryfeature '!static'
277 then
278 myopts+=" --disable-static"
279 else
280 myopts+=" --enable-static"
281 fi
282 fi
283
284 # always enable shared by default but not for waf configure
285 if [[ ! -z $(./configure --help | grep -- '--.*able-shared') ]] &&
286 [[ -z $(./configure --version | grep waf) ]]
287 then
288 myopts+=" --enable-shared"
289 fi
290
291 ./configure \
292 --prefix=/usr \
293 --host=${CHOST} \
294 --build=${CHOST} \
295 --mandir=/usr/share/man \
296 --infodir=/usr/share/info \
297 --datadir=/usr/share \
298 --sysconfdir=/etc \
299 --localstatedir=/var/lib \
300 --libdir=/usr/$(mlibdir) \
301 ${myopts} \
302 "$@" || die "mconfigure failed"
303 else
304 echo "configure is not an executable ..."
305 exit 1
306 fi
307 }
308
309 minstall()
310 {
311 if [ -f ./[mM]akefile -o -f ./GNUmakefile ]
312 then
313 make prefix=${BINDIR}/usr \
314 datadir=${BINDIR}/usr/share \
315 infodir=${BINDIR}/usr/share/info \
316 localstatedir=${BINDIR}/var/lib \
317 mandir=${BINDIR}/usr/share/man \
318 sysconfdir=${BINDIR}/etc \
319 libdir=${BINDIR}/usr/$(mlibdir) \
320 "$@" install || die "minstall failed"
321 else
322 die "no Makefile found"
323 fi
324 }
325
326 mmake()
327 {
328 make ${MAKEOPTS} ${EXTRA_EMAKE} "$@"
329 }
330
331 munpack()
332 {
333 local SRCFILE
334 local IFTAR
335 local DEST
336
337 SRCFILE=$1
338
339 if [[ -z $2 ]]
340 then
341 DEST=${BUILDDIR}
342 else
343 DEST=$2
344 fi
345
346 echo -e "${COLBLUE}>>>${COLGREEN} Unpacking ${SOURCEDIR}/${PNAME}/${SRCFILE}${COLDEFAULT}"
347
348 [[ ! -d ${DEST} ]] && install -d ${DEST}
349
350 case "${SRCFILE##*.}" in
351 bz2)
352 IFTAR="$(basename $SRCFILE .bz2)"
353 IFTAR="${IFTAR##*.}"
354 if [[ ${IFTAR} = tar ]]
355 then
356 tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tar.bz2 unpack failed."
357 else
358 pushd ${DEST} > /dev/null
359 bzcat ${SOURCEDIR}/${PNAME}/${SRCFILE} > ${DEST}/$(basename ${SRCFILE} .bz2) || die ".bz2 unpack failed."
360 popd > /dev/null
361 fi
362 ;;
363 gz)
364 IFTAR="$(basename $SRCFILE .gz)"
365 IFTAR="${IFTAR##*.}"
366 if [[ ${IFTAR} = tar ]]
367 then
368 tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tar.gz unpack failed."
369 else
370 pushd ${DEST} > /dev/null
371 zcat ${SOURCEDIR}/${PNAME}/${SRCFILE} > ${DEST}/$(basename ${SRCFILE} .gz) || die ".gz unpack failed."
372 popd > /dev/null
373 fi
374 ;;
375 xz)
376 IFTAR="$(basename $SRCFILE .xz)"
377 IFTAR="${IFTAR##*.}"
378 if [[ ${IFTAR} = tar ]]
379 then
380 tar --no-same-owner -xvJf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tar.xz unpack failed."
381 else
382 pushd ${DEST} > /dev/null
383 xzcat ${SOURCEDIR}/${PNAME}/${SRCFILE} > ${DEST}/$(basename ${SRCFILE} .xz) || die ".xz unpack failed."
384 popd > /dev/null
385 fi
386 ;;
387 tbz2|mpks|mpk)
388 tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tbz2 unpack failed."
389 ;;
390 tgz)
391 tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tgz unpack failed."
392 ;;
393 txz|mpkzs|mpkz)
394 tar --no-same-owner -xvJf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".txz unpack failed."
395 ;;
396 rar)
397 unrar x ${SOURCEDIR}/${PNAME}/${SRCFILE} ${DEST} || die ".rar unpack failed."
398 ;;
399 zip|xpi|jar)
400 unzip ${SOURCEDIR}/${PNAME}/${SRCFILE} -d ${DEST} || die ".zip unpack failed."
401 ;;
402 rpm)
403 pushd ${DEST} > /dev/null
404 rpm2targz ${SOURCEDIR}/${PNAME}/${SRCFILE} || die "rpm2targz: .rpm unpack failed."
405 tar --no-same-owner -xvzf ${SRCFILE/.rpm/.tar.gz} || die "tar: .rpm unpack failed."
406 if [[ -f ${DEST}/${SRCFILE/.rpm/.tar.gz} ]]
407 then
408 rm ${DEST}/${SRCFILE/.rpm/.tar.gz}
409 fi
410 ;;
411 *)
412 die "munpack failed"
413 ;;
414 esac
415 }
416
417 mpatch()
418 {
419 local PATCHOPTS
420 local PATCHFILE
421 local i
422
423 PATCHOPTS=$1
424 PATCHFILE=$2
425
426 if [[ -z $2 ]]
427 then
428 PATCHFILE=$1
429
430 ## patch level auto-detection, get patch level
431 for ((i=0; i < 10; i++))
432 do
433 patch --dry-run -Np${i} -i ${SOURCEDIR}/${PNAME}/${PATCHFILE} > /dev/null
434 if [[ $? = 0 ]]
435 then
436 PATCHOPTS="-Np${i}"
437 break
438 fi
439 done
440 fi
441
442 echo -e "${COLBLUE}*** ${COLGREEN}Applying patch '${PATCHFILE}'${COLDEFAULT}"
443 patch "${PATCHOPTS}" -i ${SOURCEDIR}/${PNAME}/${PATCHFILE}
444 }
445
446 mlibtoolize()
447 {
448 local opts="$@"
449 [[ -z ${opts} ]] && opts="--verbose --install --force"
450
451 libtoolize ${opts} || die "running: mlibtoolize ${opts}"
452 }
453
454 mautoreconf()
455 {
456 local opts="$@"
457 [[ -z ${opts} ]] && opts="--verbose --install --force"
458
459 autoreconf ${opts} || die "running: mautoreconf ${opts}"
460 }
461
462 minstalldocs()
463 {
464 local docfiles
465 local doc
466 docfiles="$@"
467
468 if [ ! -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} ]
469 then
470 install -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "creating doc dirs."
471 fi
472
473 for doc in ${docfiles}
474 do
475 if [ -f ${doc} ]
476 then
477 if mqueryfeature "compressdoc"
478 then
479 cat ${doc} | gzip -9c > ${BINDIR}/usr/share/doc/${PNAME}-${PVER}/$(basename ${doc}).gz || die "gzipping +installing ${doc}."
480 chmod 0644 ${BINDIR}/usr/share/doc/${PNAME}-${PVER}/$(basename ${doc}).gz || die "fixing permissions of ${doc}."
481 else
482 install -m 0644 ${doc} ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "installing ${doc}."
483 fi
484 fi
485 done
486 }
487
488 mstriplibs()
489 {
490 local stripdir="$@"
491
492 [[ -z ${stripdir} ]] && stripdir="${BINDIR}"
493 [[ -z ${STRIP_DYN_LIB} ]] && STRIP_DYN_LIB="--strip-debug"
494 find ${stripdir} ! -type d | xargs --no-run-if-empty file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs --no-run-if-empty strip ${STRIP_DYN_LIB} 2> /dev/null
495 }
496
497 mstripbins()
498 {
499 local stripdir="$@"
500
501 [[ -z ${stripdir} ]] && stripdir="${BINDIR}"
502 [[ -z ${STRIP_DYN_BIN} ]] && STRIP_DYN_BIN="--strip-debug"
503 find ${stripdir} ! -type d | xargs --no-run-if-empty file | grep "executable" | grep ELF | cut -f 1 -d : | xargs --no-run-if-empty strip ${STRIP_DYN_BIN} 2> /dev/null
504 }
505
506 mstripstatic()
507 {
508 local stripdir="$@"
509
510 [[ -z ${stripdir} ]] && stripdir="${BINDIR}"
511 [[ -z ${STRIP_STATIC_LIB} ]] && STRIP_STATIC_LIB="--strip-debug"
512 find ${stripdir} ! -type d | xargs --no-run-if-empty file | grep "ar archive" | cut -f 1 -d : | xargs --no-run-if-empty strip ${STRIP_STATIC_LIB} 2> /dev/null
513 }
514
515 mstriplibtoolarchive()
516 {
517 local stripdir="$@"
518
519 [[ -z ${stripdir} ]] && stripdir="${BINDIR}"
520 find ${stripdir} ! -type d -name \*.la | xargs --no-run-if-empty file | grep "libtool library" | cut -f 1 -d : | xargs --no-run-if-empty rm -f -- 2> /dev/null
521 }
522
523 mpurgetargets()
524 {
525 local stripdir="$@"
526 local target
527
528 [[ -z ${stripdir} ]] && stripdir=${BINDIR}
529 # nothing to do in this case
530 [[ -z ${PURGE_TARGETS[*]} ]] && return
531
532 for target in ${PURGE_TARGETS[*]}
533 do
534 # check if target is a regex pattern without any slashes
535 if [[ ${target} = ${target//\/} ]]
536 then
537 find ${BINDIR} -type f -name "${target}" | xargs --no-run-if-empty rm -f -- 2> /dev/null
538 else
539 rm -f -- ${target} 2> /dev/null
540 fi
541 done
542 }
543
544 mcompressdocs()
545 {
546 local bindir="$@"
547
548 if [ -d ${bindir}/usr/share/man ]
549 then
550 echo -e "${COLBLUE}===${COLGREEN} compressing man-pages ...${COLDEFAULT}"
551 ${MLIBDIR}/compressdoc -g -9 ${bindir}/usr/share/man
552 fi
553
554 if [ -d ${bindir}/usr/share/info ]
555 then
556 echo -e "${COLBLUE}===${COLGREEN} compressing info-pages ...${COLDEFAULT}"
557 ${MLIBDIR}/compressdoc -g -9 ${bindir}/usr/share/info
558 fi
559 }
560
561 sminclude()
562 {
563 local i
564
565 if [[ -n "$@" ]]
566 then
567 for i in $@
568 do
569 [[ ${SILENT} = 1 ]] || echo "--- Including ${SMAGESCRIPTSDIR}/include/${i}.sminc"
570 source ${SMAGESCRIPTSDIR}/include/${i}.sminc
571 done
572 [[ ${SILENT} = 1 ]] || echo
573 fi
574 }
575
576 march()
577 {
578 local retval
579
580 if [[ ! -z ${ARCH} ]]
581 then
582 echo "${ARCH}"
583 retval=0
584 else
585 retval=1
586 fi
587
588 return "${retval}"
589 }
590
591 marchsrcfile()
592 {
593 local retval
594 local var="$1"
595
596 [[ -z ${var} ]] && var="SRCFILE"
597
598 if [[ ! -z $(eval echo \$${var}_${ARCH/i*86/x86}) ]]
599 then
600 eval echo \$${var}_${ARCH/i*86/x86} | tr ';' '\n'
601 retval=0
602 else
603 retval=1
604 fi
605
606 return "${retval}"
607 }
608
609 marchsrcdir()
610 {
611 local retval
612 local var="$1"
613
614 [[ -z ${var} ]] && var="SRCDIR"
615
616 if [[ ! -z $(eval echo \$${var}_${ARCH/i*86/x86}) ]]
617 then
618 eval echo \$${var}_${ARCH/i*86/x86} | tr ';' '\n'
619 retval=0
620 else
621 retval=1
622 fi
623
624 return "${retval}"
625 }
626
627 marchdepend()
628 {
629 local retval
630 local var="$1"
631
632 [[ -z ${var} ]] && var="DEPEND"
633
634 if [[ ! -z $(eval echo \$${var}_${ARCH/i*86/x86}) ]]
635 then
636 echo "\$(eval echo \\\$${var}_\${ARCH/i*86/x86} | tr ';' '\n')"
637 retval=0
638 else
639 retval=1
640 fi
641
642 return "${retval}"
643 }
644
645 marchsdepend()
646 {
647 local retval
648 local var="$1"
649
650 [[ -z ${var} ]] && var="SDEPEND"
651
652 if [[ ! -z $(eval echo \$${var}_${ARCH/i*86/x86}) ]]
653 then
654 echo "\$(eval echo \\\$${var}_\${ARCH/i*86/x86} | tr ';' '\n')"
655 retval=0
656 else
657 retval=1
658 fi
659
660 return "${retval}"
661 }
662
663 setup_distcc_environment()
664 {
665 if [ -x /usr/bin/distcc ]
666 then
667 echo -e "${COLBLUE}---${COLGREEN} Using DistCC for compilation ...${COLDEFAULT}"
668 export PATH=/usr/$(mlibdir)/distcc/bin:${PATH} || die "distcc: could not export new $PATH"
669
670 export DISTCC_DIR="${DISTCC_DIR}" || die "distcc_dir export failed"
671
672 # creating distcc tempdir
673 install -o distcc -g daemon -d ${DISTCC_DIR}
674 chmod 1777 ${DISTCC_DIR}
675 fi
676 }
677
678 setup_icecc_environment()
679 {
680 if [ -x /usr/bin/icecc ]
681 then
682 echo -e "${COLBLUE}---${COLGREEN} Using IceCC for compilation ...${COLDEFAULT}"
683 export PATH=/usr/$(mlibdir)/icecc/bin:${PATH} || die "icecc: could not export new $PATH"
684 fi
685 }
686
687 setup_ccache_environment()
688 {
689 if [ -x /usr/bin/ccache ]
690 then
691 mqueryfeature "icecc" && export CCACHE_PREFIX=icecc
692
693 echo -e "${COLBLUE}---${COLGREEN} Using CCache for compilation ...${COLDEFAULT}"
694 export PATH=/usr/$(mlibdir)/ccache/bin:${PATH} || die "ccache: could not export new $PATH"
695 fi
696 }
697
698 # build_mage_script(): helper functions for regen_mage_tree()
699 # generates an mage file with given information in smage file
700 # needs at least:
701 # PNAME name of pkg
702 # PVER version
703 # PBUILD revision
704 # PCAT category of the pkg
705 # PCATEGORIE category of the pkg (deprecated, use PCAT!)
706 # STATE state of pkg stable|unstable|old
707 # DESCRIPTION a short description (opt)
708 # HOMEPAGE homepage (opt)
709 # LICENSE license information of the pkg (opt)
710 # DEPEND runtime dependencies (opt)
711 # SDEPEND adds needed deps to build the pkg (opt)
712 # PROVIDE provides a virtual (opt)
713 #
714 # special tags:
715 # PKGTYPE type of pkg
716 # INHERITS which functions get included
717 # SPECIAL_FUNCTIONS special functions which should also be added
718 # warning: they get killed before the build starts !
719 # SPLIT_PACKAGES names of all subpackages which are splitted from parent
720 # SPLIT_PACKAGE_BASE base package name for splitpackages
721 # (only in the resulting magefile}
722 #
723 # MAGE_TREE_DEST target destination of the generated tree
724 # REGEN_MAGE_TREE set to 'true' to enable this
725 #
726 # gets called with build_mage_script target
727 build_mage_script()
728 {
729 local magefile
730 local dest
731 local split_pkg_base
732 local sym
733 local depname
734
735 # if MAGE_TREE_DEST not set use BUILDDIR
736 : ${MAGE_TREE_DEST=${BUILDDIR}/mage-tree}
737
738 # mark package as splitpackage
739 [[ $1 = --split-pkg-base ]] && shift && split_pkg_base="$1"
740
741 # name of magefile
742 magefile="${PNAME}-${PVER}-${PBUILD}.mage"
743
744 # destination to magefile
745 dest="${MAGE_TREE_DEST}/${PCAT}/${PNAME}/${magefile}"
746
747 # show what we are doing
748 echo -e "${COLBLUE}===${COLGREEN} generating mage file:${COLDEFAULT}"
749 echo "${dest}"
750
751 install -d "$(dirname ${dest})"
752 # now build the mage file
753 > ${dest}
754
755 # pgkname and state
756 echo "PKGNAME=\"${PNAME}-${PVER}-\${ARCH}$(print_distrotag)-${PBUILD}\"" >> ${dest}
757 echo "STATE=\"${STATE}\"" >> ${dest}
758
759 # description and homepage
760 echo "DESCRIPTION=\"${DESCRIPTION}\"" >> ${dest}
761 echo "HOMEPAGE=\"${HOMEPAGE}\"" >> ${dest}
762
763 # license information
764 echo "LICENSE=\"${LICENSE}\"" >> ${dest}
765
766 # special tags and vars
767 echo "PKGTYPE=\"${PKGTYPE}\"" >> ${dest}
768
769 # split package base
770 echo "SPLIT_PACKAGE_BASE=\"${split_pkg_base}\"" >> ${dest}
771
772 # add special vars
773 if [ -n "${SPECIAL_VARS}" ]
774 then
775 local i
776 for i in ${SPECIAL_VARS}
777 do
778 # being tricky here :)
779 echo "${i}=\"$(eval echo \$${i})\"" >> ${dest}
780 done
781 fi
782
783 # add at least all includes
784 if [ -n "${INHERITS}" ]
785 then
786 echo -n "minclude" >> ${dest}
787 local i
788 for i in ${INHERITS}
789 do
790 echo -n " ${i}" >> ${dest}
791 done
792 # a CRLF is needed here!
793 echo >> ${dest}
794 fi
795
796 # deps and provides
797 echo "DEPEND=\"${DEPEND}\"" >> ${dest}
798 echo "SDEPEND=\"${SDEPEND}\"" >> ${dest}
799 echo "PROVIDE=\"${PROVIDE}\"" >> ${dest}
800
801 # add special functions
802 if [ -n "${SPECIAL_FUNCTIONS}" ]
803 then
804 local i
805 for i in ${SPECIAL_FUNCTIONS}
806 do
807 # add to mage (quotes needed !)
808 typeset -f "${i}" >> ${dest}
809 done
810 fi
811
812 # pre|post-install|removes
813 typeset -f preinstall >> ${dest}
814 typeset -f postinstall >> ${dest}
815 typeset -f preremove >> ${dest}
816 typeset -f postremove >> ${dest}
817 }
818
819 regen_mage_tree()
820 {
821 local subpackage
822
823 # build them only if requested
824 if mqueryfeature regentree
825 then
826 # run it for splitpackages
827 if [[ -n ${SPLIT_PACKAGES} ]]
828 then
829 local split_pkg_base="${PNAME}"
830 # save smage environment
831 split_save_variables
832 # build for each subpackage a mage file
833 # run it with several targets
834 echo
835 for subpackage in ${SPLIT_PACKAGES}
836 do
837 # get the right variables for the split
838 export PNAME="${subpackage}"
839 split_info_${subpackage}
840 # fix PCATEGORIE -> PCAT
841 if [[ ! -z ${PCATEGORIE} ]]
842 then
843 PCAT="${PCATEGORIE}"
844 unset PCATEGORIE
845 fi
846 # get the preinstall etc
847 split_export_inherits ${subpackage}
848 build_mage_script --split-pkg-base "${split_pkg_base}"
849 # delete split preinstall etc
850 split_delete_inherits ${subpackage}
851 # restore smage environment
852 split_restore_variables
853 done
854 echo
855 # unset all saved smage variables
856 split_unset_variables
857
858 else
859 echo
860 build_mage_script
861 echo
862 fi
863 fi
864
865 # now unset all uneeded vars to be safe
866 # unset PKGNAME <-- don't do that; smage needs this var
867 unset SPECIAL_FUNCTIONS
868 unset SPECIAL_VARS
869 unset STATE
870 unset DESCRIPTION
871 unset HOMEPAGE
872 # unset PKGTYPE <-- don't do that either; smage needs this var
873 unset INHERITS
874 unset DEPEND
875 unset SDEPEND
876 unset PROVIDE
877 unset preinstall
878 unset postinstall
879 unset preremove
880 unset postremove
881 }
882
883 split_save_variables()
884 {
885 export SAVED_PNAME="${PNAME}"
886 export SAVED_PVER="${PVER}"
887 export SAVED_PBUILD="${PBUILD}"
888 export SAVED_PCAT="${PCAT}"
889 export SAVED_DESCRIPTION="${DESCRIPTION}"
890 export SAVED_HOMEPAGE="${HOMEPAGE}"
891 export SAVED_SPECIAL_VARS="${SPECIAL_VARS}"
892 export SAVED_SPECIAL_FUNCTIONS="${SPECIAL_FUNCTIONS}"
893 export SAVED_STATE="${STATE}"
894 export SAVED_INHERITS="${INHERITS}"
895 export SAVED_DEPEND="${DEPEND}"
896 export SAVED_SDEPEND="${SDEPEND}"
897 export SAVED_PROVIDE="${PROVIDE}"
898 export SAVED_PKGTYPE="${PKGTYPE}"
899
900 # special handling needed for mage features
901 # pkgbuild
902 mqueryfeature "pkgbuild" && export SAVED_FEATURE_PKGBUILD="pkgbuild"
903 mqueryfeature "!pkgbuild" && export SAVED_FEATURE_PKGBUILD="!pkgbuild"
904 # strip
905 mqueryfeature "strip" && export SAVED_FEATURE_STRIP="strip"
906 mqueryfeature "!strip" && export SAVED_FEATURE_STRIP="!strip"
907 # libtool
908 mqueryfeature "libtool" && export SAVED_FEATURE_LIBTOOL="libtool"
909 mqueryfeature "!libtool" && export SAVED_FEATURE_LIBTOOL="!libtool"
910 # compressdoc
911 mqueryfeature "compressdoc" && export SAVED_FEATURE_COMPRESSDOC="compressdoc"
912 mqueryfeature "!compressdoc" && export SAVED_FEATURE_COMPRESSDOC="!compressdoc"
913
914 # bindir too
915 export SAVED_BINDIR="${BINDIR}"
916
917 # export the SPLIT_PACKAGE_BASE
918 export SPLIT_PACKAGE_BASE="${SAVED_PNAME}"
919
920 # functions
921 if [[ ! -z $(typeset -f preinstall) ]]
922 then
923 # rename the old one
924 local saved_preinstall
925 saved_preinstall=SAVED_$(typeset -f preinstall)
926 eval "${saved_preinstall}"
927 export -f SAVED_preinstall
928 fi
929
930 if [[ ! -z $(typeset -f postinstall) ]]
931 then
932 # rename the old one
933 local saved_postinstall
934 saved_postinstall=SAVED_$(typeset -f postinstall)
935 eval "${saved_postinstall}"
936 export -f SAVED_postinstall
937 fi
938
939 if [[ ! -z $(typeset -f preremove) ]]
940 then
941 # rename the old one
942 local saved_preremove
943 saved_preremove=SAVED_$(typeset -f preremove)
944 eval "${saved_preremove}"
945 export -f SAVED_preremove
946 fi
947
948 if [[ ! -z $(typeset -f postremove) ]]
949 then
950 # rename the old one
951 local saved_postremove
952 saved_postremove=SAVED_$(typeset -f postremove)
953 eval "${saved_postremove}"
954 export -f SAVED_postremove
955 fi
956 }
957
958 split_restore_variables()
959 {
960 export PNAME="${SAVED_PNAME}"
961 export PVER="${SAVED_PVER}"
962 export PBUILD="${SAVED_PBUILD}"
963 export PCAT="${SAVED_PCAT}"
964 export DESCRIPTION="${SAVED_DESCRIPTION}"
965 export HOMEPAGE="${SAVED_HOMEPAGE}"
966 export SPECIAL_VARS="${SAVED_SPECIAL_VARS}"
967 export SPECIAL_FUNCTIONS="${SAVED_SPECIAL_FUNCTIONS}"
968 export STATE="${SAVED_STATE}"
969 export INHERITS="${SAVED_INHERITS}"
970 export DEPEND="${SAVED_DEPEND}"
971 export SDEPEND="${SAVED_SDEPEND}"
972 export PROVIDE="${SAVED_PROVIDE}"
973 export PKGTYPE="${SAVED_PKGTYPE}"
974
975 # special handling needed for mage features
976 # pkgbuild
977 FVERBOSE=off msetfeature "${SAVED_FEATURE_PKGBUILD}"
978 # strip
979 FVERBOSE=off msetfeature "${SAVED_FEATURE_STRIP}"
980 # libtool
981 FVERBOSE=off msetfeature "${SAVED_FEATURE_LIBTOOL}"
982 # compressdoc
983 FVERBOSE=off msetfeature "${SAVED_FEATURE_COMPRESSDOC}"
984
985 # bindir too
986 export BINDIR="${SAVED_BINDIR}"
987
988 # functions
989 if [[ ! -z $(typeset -f SAVED_preinstall) ]]
990 then
991 # rename the old one
992 local saved_preinstall
993 saved_preinstall=$(typeset -f SAVED_preinstall)
994 eval "${saved_preinstall/SAVED_/}"
995 export -f preinstall
996 fi
997
998 if [[ ! -z $(typeset -f SAVED_postinstall) ]]
999 then
1000 # rename the old one
1001 local saved_postinstall
1002 saved_postinstall=$(typeset -f SAVED_postinstall)
1003 eval "${saved_postinstall/SAVED_/}"
1004 export -f postinstall
1005 fi
1006
1007 if [[ ! -z $(typeset -f SAVED_preremove) ]]
1008 then
1009 # rename the old one
1010 local saved_preremove
1011 saved_preremove=$(typeset -f SAVED_preremove)
1012 eval "${saved_preremove/SAVED_/}"
1013 export -f preremove
1014 fi
1015
1016 if [[ ! -z $(typeset -f SAVED_postremove) ]]
1017 then
1018 # rename the old one
1019 local saved_postremove
1020 saved_postremove=$(typeset -f SAVED_postremove)
1021 eval "${saved_postremove/SAVED_/}"
1022 export -f postremove
1023 fi
1024 }
1025
1026 split_unset_variables()
1027 {
1028 # unset saved vars; not needed anymore
1029 unset SAVED_PNAME
1030 unset SAVED_PVER
1031 unset SAVED_PBUILD
1032 unset SAVED_PCAT
1033 unset SAVED_DESCRIPTION
1034 unset SAVED_HOMEPAGE
1035 unset SAVED_SPECIAL_VARS
1036 unset SAVED_SPECIAL_FUNCTIONS
1037 unset SAVED_STATE
1038 unset SAVED_PKGTYPE
1039 unset SAVED_INHERITS
1040 unset SAVED_DEPEND
1041 unset SAVED_SDEPEND
1042 unset SAVED_PROVIDE
1043 unset SAVED_BINDIR
1044 unset SAVED_PKGTYPE
1045 unset SAVED_FEATURE_PKGBUILD
1046 unset SAVED_FEATURE_STRIP
1047 unset SAVED_FEATURE_LIBTOOL
1048 unset SAVED_FEATURE_COMPRESSDOC
1049 unset SPLIT_PACKAGE_BASE
1050 unset -f SAVED_preinstall
1051 unset -f SAVED_postinstall
1052 unset -f SAVED_preremove
1053 unset -f SAVED_postremove
1054 }
1055
1056 split_export_inherits()
1057 {
1058 local subpackage="$1"
1059 local func
1060 local newfunc
1061
1062 for func in preinstall postinstall preremove postremove
1063 do
1064 if [[ ! -z $(typeset -f ${func}_${subpackage}) ]]
1065 then
1066 newfunc=$(typeset -f ${func}_${subpackage})
1067 newfunc="${newfunc/_${subpackage} (/ (}"
1068 eval "${newfunc}"
1069 fi
1070 done
1071 }
1072
1073 split_delete_inherits()
1074 {
1075 local subpackage="$1"
1076 local func
1077
1078 for func in preinstall postinstall preremove postremove
1079 do
1080 if [[ ! -z $(typeset -f ${func}_${subpackage}) ]]
1081 then
1082 unset -f ${func}
1083 fi
1084 done
1085 }
1086
1087 export_inherits()
1088 {
1089 local include="$1"
1090 shift
1091
1092 while [ "$1" ]
1093 do
1094 local functions="$1"
1095
1096 # sanity checks
1097 [ -z "${include}" ] && die "export_inherits(): \$include not given."
1098 [ -z "${functions}" ] && die "export_inherits(): \$functions not given."
1099
1100 eval "${functions}() { ${include}_${functions} ; }"
1101
1102 # debug
1103 [[ ${MAGEDEBUG} = on ]] && typeset -f "${functions}"
1104
1105 shift
1106 done
1107 }
1108
1109 generate_package_md5sum()
1110 {
1111 local dest
1112 local pcat
1113 local pname
1114 local pver
1115 local pbuild
1116 local parch
1117 local pkgname
1118
1119 # very basic getops
1120 for i in $*
1121 do
1122 case $1 in
1123 --pcat|-c) shift; pcat="$1" ;;
1124 --pname|-n) shift; pname="$1" ;;
1125 --pver|-v) shift; pver="$1" ;;
1126 --pbuild|-b) shift; pbuild="$1" ;;
1127 --parch|a) shift; parch="$1" ;;
1128 esac
1129 shift
1130 done
1131
1132 # sanity checks; abort if not given
1133 [ -z "${pcat}" ] && die "generate_package_md5sum() \$pcat not given."
1134 [ -z "${pname}" ] && die "generate_package_md5sum() \$pname not given."
1135 [ -z "${pver}" ] && die "generate_package_md5sum() \$pver not given."
1136 [ -z "${pbuild}" ] && die "generate_package_md5sum() \$pbuild not given."
1137 [ -z "${parch}" ] && die "generate_package_md5sum() \$parch not given."
1138
1139 # check needed global vars
1140 [ -z "${PKGDIR}" ] && die "generate_package_md5sum() \$PKGDIR not set."
1141 [ -z "${PKGSUFFIX}" ] && die "generate_package_md5sum() \$PKGSUFFIX not set."
1142
1143 # build pkgname
1144 pkgname="${pname}-${pver}-${parch}$(print_distrotag)-${pbuild}"
1145
1146 # build pkg-md5-sum only if requested
1147 if mqueryfeature regentree
1148 then
1149 echo -ne "${COLBLUE}===${COLGREEN} generating md5's for ${pkgname}.${PKGSUFFIX} ... ${COLDEFAULT}"
1150
1151 # abort if not exist
1152 if [ ! -f ${PKGDIR}/${pkgname}.${PKGSUFFIX} ]
1153 then
1154 echo -e "${COLRED}! exists${COLDEFAULT}"
1155 return 0
1156 fi
1157
1158 # if MAGE_TREE_DEST not set use BUILDDIR
1159 : ${MAGE_TREE_DEST=${BUILDDIR}/mage-tree}
1160
1161 # setup md5 dir
1162 dest="${MAGE_TREE_DEST}/${pcat}/${pname}/md5"
1163 install -d ${dest}
1164
1165 # gen md5sum
1166 ( cd ${PKGDIR}; md5sum "${pkgname}.${PKGSUFFIX}" ) \
1167 > ${dest}/${pkgname}.md5
1168 echo -e "${COLGREEN}done${COLDEFAULT}"
1169 fi
1170 }
1171
1172 source_pkg_build()
1173 {
1174 if [[ ${PKGTYPE} = virtual ]]
1175 then
1176 echo "Virtual package detected; src-pkg-tarball not necessary ..."
1177 return 0
1178 fi
1179
1180 if [[ ! -d ${SOURCEDIR}/${PNAME} ]]
1181 then
1182 echo "No SRC_URI defined; src-pkg-tarball not necessary ..."
1183 return 0
1184 fi
1185
1186 [ -z "${SRCPKGDIR}" ] && die "\$SRCPKGDIR not found. Please setup your ${MAGERC} correctly."
1187
1188 echo -e "${COLGREEN}Creating source package tarball ... ${COLDEFAULT}"
1189
1190 # include the smage2 file
1191 cp ${SMAGENAME} ${SOURCEDIR}/${PNAME}
1192
1193 ( cd ${SOURCEDIR}; tar cvjf ${BUILDDIR}/${PNAME}-${PVER}-${PBUILD}.tar.bz2 ${PNAME}; )
1194 [[ ! -d ${SRCPKGDIR} ]] && install -d ${SRCPKGDIR}
1195 mv ${BUILDDIR}/${PNAME}-${PVER}-${PBUILD}.tar.bz2 ${SRCPKGDIR}/${PNAME}-${PVER}-${PBUILD}.${SRCPKGSUFFIX}
1196
1197 echo -e "${COLGREEN}Source package ${COLBLUE}${PNAME}-${PVER}-${PBUILD}.${SRCPKGSUFFIX} ${COLGREEN}successfully builded.${COLDEFAULT}\n"
1198 }
1199
1200 step_by_step()
1201 {
1202 if mqueryfeature stepbystep
1203 then
1204 echo -e "${COLRED}Step-by-step enabled! Paused after $1.${COLDEFAULT}"
1205 echo "Press [enter] to continue"
1206 read
1207 fi
1208 }
1209
1210 resume_stamp()
1211 {
1212 local step="$1"
1213 [[ ! -d ${BUILDDIR}/.stamps ]] && install -d ${BUILDDIR}/.stamps
1214 touch ${BUILDDIR}/.stamps/smage-${PKGNAME}-${step}
1215 }
1216
1217 run_resume()
1218 {
1219 local step="$1"
1220
1221 if mqueryfeature "resume" && [[ -f ${BUILDDIR}/.stamps/smage-${PKGNAME}-${step} ]]
1222 then
1223 echo -e "${COLMAGENTA}${step} already processed; doing nothing${COLDEFAULT}"
1224 return 0
1225 else
1226 return 1
1227 fi
1228 }
1229
1230 mqalint()
1231 {
1232 return 0
1233 }